<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un block et vérifie les droits d'accès
 *APRES l'inclusion du common_block les variables suivantes sont créées:
 *PHP:
 *      $dbconnection objet PDO de connexion à la DB
 *      $webplugin_path chemin d'accès au web plugin de repport (default: /usr/local/esia/public_html/plugin/report/
 *      $lang tableau associatif avec les variables de langue
 *      $action l'action passé dans l'url ou 'view'
 *      $gendate tableau associatif reprenant les paramètres global avec les clés suivantes:
 *               ['start']  timestamps de début
 *               ['end']    timestamps de fin
 *               ['interval'] interval en nombre de jour au format php. voir %a par rapport à la date de début  https://www.php.net/manual/fr/dateinterval.format.php
 *      $block les données du block en DB
 *      $parameters un tableau associatif reprenant les paramètres du block
 * SMARTY
 *      $block les informations du block
 *      $parameters les parametres du block (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
require_once REPORT_COMMON_BLOCK;
if($action=="generate")
{	
	$data = Model_adm::getGDPRRegister($dbconnection);
	$smarty->assign('data',$data);
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates/';
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$parameters['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$parameters['title']['style']['font-size']=$TaillePoliceTitle."px";
			$parameters['title']['style']['text-align']=$_POST["nameposition"];
			$parameters['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$parameters['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$parameters['description']['style']['font-size']=$TaillePoliceDescr."px";
			$parameters['description']['style']['text-align']=$_POST["desciptionposition"];
			
			// Affichage colonne			
			$parameters['affiche_message']=$_POST['messageError'];
			$parameters['affiche_groupNoeud']=$_POST['groupNoeud'];
			$parameters['affiche_type']=$_POST['type'];
					
			$paramSave = json_encode($parameters);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	assignCommonStyles($smarty,$parameters);
	$smarty->assign('action','update');
}
$smarty->display($webplugin_path.'/blocks/templates/block_gpdr.html');
?>
