<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$apache_plugin_path = $arr[0]['apache_path'];
$egide_path = $path.$apache_plugin_path;

include $egide_path.'/libs/egide_common.libs.php';

if($action=="generate")
{
	//code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas
	if($parameters['type']=="groupenoeud")
	{
		$nodeList = array();
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
		foreach ($tab_group_node as $node)
		{
			$nodeList[] = $node->getId();
		}
	}
	else
	{
		$nodeList = $parameters['nodeid'] ;
	}

	$listcve = Model_egidescan::getCVEByScoring($dbconnection,$userid,$nodeList);

	$toShortIdList = array();
	$toShortCVEList = array();
	foreach($listcve as $cve)
	{
		$toShortIdList[$cve['id']] = $cve['number'];
		$toShortCVEList[$cve['id']] = $cve;
	}
	arsort($toShortIdList);

	$severity_table = array();
	foreach($toShortIdList as $cveid => $unusedvar)
	{
		$row = $toShortCVEList[$cveid];
		$ret = array();

		$l_severity= $cve['severity'];
		if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_severity,$lang))
		{
			$l_severity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_severity];
		}
		$l_complexity = $cve['complexity'];
		if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity,$lang))
		{
			$l_complexity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity];
		}

		if($parameters['affiche_CVE']=='on')
		{
			$ret['vulnerability_id'] = $row['id'];
		}
		if($parameters['affiche_MATCHES']=='on')
		{
			$ret['match_noeud'] = $row['number'];
		}
		if($parameters['affiche_DESCRIPTION']=='on')
		{
			$ret['vulnerability_description'] = $row['description'];
		}
		if($parameters['affiche_SCORING']=='on')
		{
			$ret['vulnerability_scoring'] = array('value'=>$row['scoring'],'color'=>ESIA\Egide\getCSSClassByscore($row['scoring']));
		}
		if($parameters['affiche_SEVERITY']=='on')
		{
			$ret['cve_severt'] = $l_severity;
		}
		if($parameters['affiche_COMPLEXITY']=='on')
		{
			$ret['cve_cmplx'] = $l_complexity;
		}
		$severity_table[] =$ret;
		$sortedArray_index++;
		if( $sortedArray_index >= $parameters['nbr_cve'])
		{
			break;
		}
	}
	$smarty->assign('vulnerability_array_top10',$severity_table);
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}
elseif($action=="update")
{
	//Code permettant l'administration du bloc
	$parameters = $block['parameters'];
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		//on traite le formulaire
		try
		{
			//traite les données post pour le style du titre et de la description
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];
			$parameters['affiche_CVE']=$_POST['CVE'];
			$parameters['affiche_MATCHES']=$_POST['MATCHES'];
			$parameters['affiche_DESCRIPTION']=$_POST['DESCRIPTION'];
			$parameters['affiche_SCORING']=$_POST['SCORING'];
			$parameters['affiche_SEVERITY']=$_POST['SEVERITY'];
			$parameters['affiche_COMPLEXITY']=$_POST['COMPLEXITY'];
			$parameters['nbr_cve']=$_POST['nbr_cve'];
			if($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			else
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
			}

			//traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
			//la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$block['option']=$parameters;
			$smarty->assign('block',$block);
		}
		catch (EsiaDbException $e)
		{
			//la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//OBSOLETE
	//$adm_list_group_node = ESIA\Egide\getAdmListNodes($dbconnection,$user,$parameters);
	//$smarty->assign('adm_list_group_node', $adm_list_group_node);

	$smarty->assign('param',$parameters);
	assignCommonStyles($smarty,$parameters);

	//récupération des données pour l'affichage
	//on fixe le mode update
	$smarty->assign('action','update');
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/egidescan.html');
?>
