<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$apache_plugin_path = $arr[0]['apache_path'];
$egide_path = $path.$apache_plugin_path;
include $egide_path.'/lang/'.$language.'.php';

$smarty->assign('lang', $lang);

include $egide_path.'/libs/egide_common.libs.php';

if($action == 'generate')
{
	$param = $block['parameters'];
	$nodeList = array();
	if(!empty($param['groupnodeid']))
	{
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection, $userid, $param['groupnodeid']);
		foreach($tab_group_node as $node)
		{
			$nodeList[] = $node->getId();
		}
	}
	elseif(!empty($param['nodeid']))
	{
		$nodeList = $param['nodeid'] ;
	}

	if(!empty($nodeList))
	{
		$severityChartData = Model_egidescan::getNumberGlobalByScoringChartColumn($dbconnection, $userid, $nodeList);
		$complexityCount = Model_egidescan::getNodeComplexityCountsByIface($dbconnection, $userid, $nodeList);
	}
	else
	{
		$scoringCounts = array(
			'0 - 1' => 0,
			'1 - 2' => 0,
			'2 - 3' => 0,
			'3 - 4' => 0,
			'4 - 5' => 0,
			'5 - 6' => 0,
			'6 - 7' => 0,
			'7 - 8' => 0,
			'8 - 9' => 0,
			'9 - 10' => 0,
		);
		$severityChartData = array(
			'x' => array_keys($scoringCounts),
			'y' => array_values($scoringCounts),
		);
		$complexityCount = array(
			'LOW' => 0,
			'MEDIUM' => 0,
			'HIGH' => 0,
			'CRITICAL' => 0,
		);
	}

	$smarty->assign('severityChartData', $severityChartData);
	$smarty->assign('complexityCount', $complexityCount);

	$smarty->assign('include_id', $block['include_id']);
}
elseif($action=="update")
{
	//Code permettant l'administration du bloc
	$parameters = $block['parameters'];
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		//on traite le formulaire
		try
		{
			//traite les données post pour le style du titre et de la description
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];
			if($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			else
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
			}
			//traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
            //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$block['option']=$parameters;
			$smarty->assign('block',$block);
		}
		catch(EsiaDbException $e)
		{
            //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		$smarty->assign('parameters',$parameters);
	}
	//récupération des styles:
	$smarty->assign('param',$parameters);
	assignCommonStyles($smarty,$parameters);
	//récupération des données pour l'affichage
	//on fixe le mode update
	$smarty->assign('action','update');
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/egidescan_severity.html');
?>
