<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un block et vérifie les droits d'accès
 *APRES l'inclusion du common_block les variables suivantes sont créées:
 *PHP:
 *      $dbconnection objet PDO de connexion à la DB
 *      $webplugin_path chemin d'accès au web plugin de repport (default: /usr/local/esia/public_html/plugin/report/
 *      $lang tableau associatif avec les variables de langue
 *      $action l'action passé dans l'url ou 'view'
 *      $gendate tableau associatif reprenant les paramètres global avec les clés suivantes:
 *               ['start']  timestamps de début
 *               ['end']    timestamps de fin
 *               ['interval'] interval en nombre de jour au format php. voir %a par rapport à la date de début  https://www.php.net/manual/fr/dateinterval.format.php
 *      $block les données du block en DB
 *      $parameters un tableau associatif reprenant les paramètres du block
 * SMARTY
 *      $block les informations du block
 *      $parameters les parametres du block (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
require_once REPORT_COMMON_BLOCK;
if($action=="generate")
{
    $list_incident = array();
    $data=array();
    //gestion du niveau d'erreur
    $error_type ='';
    if(!array_key_exists('highligth_warning', $parameters))
    {
    	$parameters['highligth_warning']=30;
    }
    if(!array_key_exists('highligth_critical', $parameters))
    {
    	$parameters['highligth_critical']=60;
    }
    if(!array_key_exists('filter_during', $parameters))
    {
    	$parameters['filter_during']=0;
    }
    if($parameters['affiche_critical']=='on')
    {
        $error_type .='critical,';
    }
    if($parameters['affiche_warning']=='on')
    {
        $error_type .='warning,';
    }
    if($parameters['affiche_unknown']=='on')
    {
        $error_type .='unknown,';
    }
    $error_type = rtrim($error_type,',');
    $pluginfilter=false;
	if($parameters['type']=="service")
	{
		if(!empty($parameters['serviceid']))
		{
        	$data = Model_Report::getRepportIncidentBlock($dbconnection,$start,$end,$parameters['serviceid'],Model_Report::BYSERVICE,$error_type);
		}
	}
	elseif($parameters['type']=="noeud" || $parameters['type']=="groupenoeud")
	{
        $tab_id_node = array();
        //on créer un tableau de noeud
        if($parameters['type']=="groupenoeud")
        {
            $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
            foreach ($tab_group_node as $node)
            {
                $tab_id_node[] = $node->getId();
            }
            if(!empty($parameters['plugin']))
            {
                if( ! in_array(-1,$parameters['plugin']))
                {
                    $pluginfilter = $parameters['plugin'];
                }
            }
        }
        else
        {
            $tab_id_node=$parameters['nodeid'];
        }
		$no_incidents_html = '';
		if(!empty($tab_id_node))
		{
        	$data = Model_Report::getRepportIncidentBlock($dbconnection,$start,$end,$tab_id_node,Model_Report::BYNODE,$error_type);
		}
	}
    $arr=array();
    $arr_list_group=array();
    foreach ($data as $line)
    {
        if(!empty($pluginfilter))
        {
            if( !in_array($line['plugin_id'],$pluginfilter))
            {
                continue;
            }
        }
        //
    	$during_minut = intdiv($line['during_second'],60);
    	if($during_minut > $parameters['filter_during'])
    	{
    		//gestion des groupe de noeuds
    		$nodegroup="";
    		if(array_key_exists($line['device_id'], $arr_list_group))
    		{
    			$nodegroup =  $arr_list_group[$line['device_id']];
    		}
    		else
    		{
    			$arr_tmp = Model_Report::getDeviceGroupByDevice($dbconnection,array($line['device_id']));
    			$nodegroup =$arr_tmp[$line['device_id']];
    			$arr_list_group = array_merge($arr_list_group,$arr_tmp);
    		}
	        $common_name = Model_esia::getCommonName($lang, $line['service_name'], $line['plugin_name']);
	        $out = preg_replace('#\|[a-zA-Z].*#',"",$line['happen_message']);
	        $out = trim($out);
	        $datestart = date_format(new DateTime($line['time']),'d/m/Y H:i:s');
	        $dateend = date_format(new DateTime($line['time_end']),'d/m/Y H:i:s');
	        $during = preg_replace('#^000#','',$line['during']);
	        if(preg_match('#^([0-9]{3})\s+([0-9\:]*)#',$during,$regs))
	        {
	            $day = ltrim($regs[1],'0');
	            if($day > 1)
	            {
	                $day = $day.' '.$lang['REPORT_DAYS'];
	            }
	            else
	            {
	                $day = $day.' '.$lang['REPORT_DAY'];
	            }
	            $during = $day.' '.$regs[2];
	        }
	        $highlight='none';
	        if($during_minut > $parameters['highligth_critical'])
	        {
	        	$highlight='critical';
	        }
	        elseif($during_minut > $parameters['highligth_warning'])
	        {
	        	$highlight='warning';
	        }
	        $arr[]= array('group_name'=>nl2br($nodegroup),
	                      'node_name'=>$line['device_name'],
	                      'description'=>htmlEntities(nl2br($line['description']), ENT_QUOTES),
	                      'ip'=>$line['ip'],
	                      'service_name'=>$common_name,
	                      'technical_name'=>$line['service_name'],
	                      'error_type'=>$line['error_type'],
	                      'message'=>$out,
	                      'start'=>$datestart,
	                      'end'=>$dateend,
	                      'during'=>$during,
	        			  'highlight'=>$highlight
	        );
    	}
    }
    $smarty->assign('incidents',$arr);
}
elseif($action=="update")
{
	//print_r($block);
	$parameters = $block['parameters'];
	if(!array_key_exists('highligth_warning', $parameters))
	{
		$parameters['highligth_warning']=30;
	}
	if(!array_key_exists('highligth_critical', $parameters))
	{
		$parameters['highligth_critical']=60;
	}
	if(!array_key_exists('filter_during', $parameters))
	{
		$parameters['filter_during']=0;
	}
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];
			// Service & Noeud
			if($parameters['type']=='service')
			{
				$parameters['nodeid']=$_POST['nodes'];
				$parameters['serviceid']=$_POST['services'];
			}
			elseif ($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			else
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
                $parameters['plugin'] = $_POST['plugins'];
			}
			// Affichage colonne
            $parameters['affiche_technical_name']=$_POST['technical_name'];
			$parameters['affiche_message']=$_POST['messageError'];
			$parameters['affiche_ip']=$_POST['add_ip'];
			$parameters['affiche_time_end']=$_POST['time_end'];
			$parameters['affiche_duree']=$_POST['duree'];
			$parameters['affiche_groupNoeud']=$_POST['groupNoeud'];
			$parameters['affiche_description']=$_POST['node_description'];
			// Affichage Erreur
			$parameters['affiche_warning']=$_POST['levelWarning'];
			$parameters['affiche_critical']=$_POST['levelCritical'];
			$parameters['affiche_unknown']=$_POST['levelUnknown'];
			//Mise en évidence des donnés
			$parameters['highligth_warning']=$_POST['highligth_warning'];
			$parameters['highligth_critical']=$_POST['highligth_critical'];
			$parameters['filter_during']=$_POST['filter_during'];
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$block['option']=$parameters;
			$smarty->assign('block',$block);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}

		$smarty->assign('block',$block);
		$smarty->assign('param',$parameters);
	}
	$smarty->assign('param',$parameters);
	//recupération des styles
	assignCommonStyles($smarty,$parameters);
	$listnode = array();
	$list_group_node =array();
	//Récupération des services
	if($parameters['type']=="service")
	{
		$smarty->assign('selectedservice',$parameters['serviceid']);
	}
	elseif($parameters['type']=="noeud")
	{
		$smarty->assign('selectednode', $parameters['nodeid']);
	}
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
}
elseif($action=="plugin")
{
    $parameters = $block['parameters'];
    $groupids;
    if($_GET["init"]==1)
    {
        if(!empty($parameters['groupnodeid']))
        {
            $groupids = $parameters['groupnodeid'];
        }
    }
    else
    {
        $groupids = json_decode(urldecode($_GET["ingroupid"]));
    }
    $arr=array();
    if(!empty($groupids))
    {
    	$selectPlugin = array();
    	if(!empty($parameters['plugin']))
    	{
    		$selectPlugin = $parameters['plugin'];
    	}
        $plugin = Model_Report::getPluginByGroupNode($dbconnection,$groupids,$user->getId());
        foreach($plugin as $id => $elem)
	    {
            $common_name = Model_esia::getCommonName($lang, $elem['name'],$elem['name']);
            $content =$common_name.' [ '.$elem['name'].' ]';
            if(in_array($elem['id'], $selectPlugin))
		    {
		    	$arr[]= array('text'=>$content,'value'=>$elem['id'],'selected'=>true);
		    }
		    else 
		    {
		    	$arr[]= array('text'=>$content,'value'=>$elem['id']);
		    }
        }
        
    }    
    if(empty($parameters['plugin']))
    {
        array_unshift($arr,array('value'=>-1,'text'=>$lang['REPORT_PLUGIN_ALL_INCIDENT'],'selected'=>1));
    }
    else
    {
        array_unshift($arr,array('value'=>-1,'text'=>$lang['REPORT_PLUGIN_ALL_INCIDENT']));
    }
    echo json_encode($arr);
    exit(0);
}
$smarty->display($webplugin_path.'/blocks/templates/incident.html');
?>
