<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IPAM');
$plugin_url = $arr[0]['apache_path'];
$index_page = $arr[0]['index_page'];

include_once $path.$plugin_url.'model_ipam.php';
include_once $path.$plugin_url.'/lang/'.$language.'.php';

$smarty->assign('lang',$lang);

if($action=="generate")
{
	$networks = array();
	$limit = NULL;
	$ignore_dhcp = !($parameters['range_dhcp'] == 'on');
	$ignore_reserved = !($parameters['range_reserved'] == 'on');

	if( $parameters['networks'] == 'all' )
	{
		$networks = Model_ipam::getMultipleNetworks($dbconnection,NULL);
		$addr_lists = Model_ipam::getBusyAddresses($dbconnection,NULL,$ignore_dhcp,$ignore_reserved,$limit);
	}
	elseif( !empty($parameters['networks']) && is_array($parameters['networks']))
	{
		$networks = Model_ipam::getMultipleNetworks($dbconnection,$parameters['networks']);
		$addr_lists = Model_ipam::getBusyAddresses($dbconnection,$parameters['networks'],$ignore_dhcp,$ignore_reserved,$limit);
	}

	$ret = array();
	foreach($networks as $network)
	{
		$ret[$network['net_id']] = $network;
	}
	$networks = $ret;

	$busy_addr['busy'] = array();
	$busy_addr['reserved'] = array();
	$busy_addr['dhcp'] = array();
	foreach($addr_lists as $addr)
	{
		$lang_key = 'IPAM_ONEADDR_' . strtoupper($retRow['reserved_type']);
		if(isset($lang[$lang_key]))
		{
			$addr['type_desc'] = $lang[$lang_key];
		}

		if( $addr['reserved_type'] == 'busy' )
		{
			$addr['descr'] = $lang['IPAM_ADD_NODE_ADVISE'];
		}
		elseif( $addr['reserved_type'] == 'reserved' )
		{
			$addr['descr'] = $addr['reserved_name']. ' by '.$addr['reserved_user'];
		}
		else
		{
			$addr['descr'] = 'DHCP';
		}
		$addr['network_name'] = $networks[$addr['net_id']]['name'];
		$addr['network_vlan'] = $networks[$addr['net_id']]['vlan_id'];
		$addr['network_site'] = $networks[$addr['net_id']]['site'];
		$busy_addr[$addr['reserved_type']][] = $addr;
	}
	$busy_addr = array_merge($busy_addr['busy'],$busy_addr['reserved'],$busy_addr['dhcp']);
	$smarty->assign('iplist',$busy_addr);
	$smarty->assign('param',$parameters);
}
elseif($action=="update")
{
	//Code permettant l'administration du bloc
	$parameters = $block['parameters'];
	if($parameters['type']=='table' || empty($parameters['type']))
	{
		$parameters['type']='table';
	}
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];

			$checkboxes = 'net_name,net_vlan,net_site,reserved_desc,last_detect,range_reserved,range_dhcp';
			foreach(explode(',',$checkboxes) as $key)
			{
				if( isset($_POST[$key]))
				{
					$parameters[$key] = $_POST[$key];
				}
				else
				{
					$parameters[$key] = NULL;
				}
			}

			if( isset($_POST['all_select']) && ($_POST['all_select'] == 'all'))
			{
				$parameters['networks']= 'all';
			}
			elseif(!empty(($_POST['networks'])))
			{
				$parameters['networks']= $_POST['networks'];
			}
			$parameters['type'] = $_POST['type'];

			//traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
			//la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$block['option']=$parameters;
			$smarty->assign('block',$block);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	$smarty->assign('param',$parameters);
	assignCommonStyles($smarty,$parameters);
	//récupération des données pour l'affichage
	//on fixe le mode update
	$smarty->assign('action','update');

	$smarty->assign('type',$parameters['type']);
	$smarty->assign('parameter',$parameters);

	$sources_list = Model_ipam::getDeviceSourceList($dbconnection,$user);
	$withNetworkSources = array();
	foreach($sources_list as $source)
	{
		if( $source['network_nb'] > 0)
		{
			if(empty($source['gesa_sn']))
			{
				$networks = Model_ipam::getNetworksList($dbconnection,'this',$user);
			}
			else
			{
				$networks = Model_ipam::getNetworksList($dbconnection,$source['device_id'],$user);
			}
			$withNetworkSources[$source['device_name']] = array();
			foreach($networks as $net)
			{
				$withNetworkSources[$source['device_name']][$net['net_id']] = $net['name'];
			}
		}
	}

	$smarty->assign('networks_list',$withNetworkSources);
	if( !isset($parameters['networks']) )
	{
		$parameters['networks'] = 'all';
	}


	if( $parameters['networks'] == 'all' )
	{
		$smarty->assign('selected','all');
	}
	else
	{
		$smarty->assign('selected','select');
		$smarty->assign('selected_networks',$parameters['networks']);
	}
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/ipam_node.html');
?>
