<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un block et vérifie les droits d'accès
 *APRES l'inclusion du common_block les variables suivantes sont créées:
 *PHP:
 *      $dbconnection objet PDO de connexion à la DB
 *      $webplugin_path chemin d'accès au web plugin de repport (default: /usr/local/esia/public_html/plugin/report/
 *      $lang tableau associatif avec les variables de langue
 *      $action l'action passé dans l'url ou 'view'
 *      $gendate tableau associatif reprenant les paramètres global avec les clés suivantes:
 *               ['start']  timestamps de début
 *               ['end']    timestamps de fin
 *               ['interval'] interval en nombre de jour au format php. voir %a par rapport à la date de début  https://www.php.net/manual/fr/dateinterval.format.php
 *      $block les données du block en DB
 *      $parameters un tableau associatif reprenant les paramètres du block
 * SMARTY
 *      $block les informations du block
 *      $parameters les parametres du block (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
require_once REPORT_COMMON_BLOCK;
$rrdpath='/usr/local/esia/public_html/data/rra/';
if($action=="generate")
{
	$param = $parameters;
	if($param['type']=="service")
	{
		$services_id=array();
		if($param['type']=="groupenoeudplugin")
		{
			foreach ($param['pluginid'] as $id)
			{
				$service = Model_esia::getServiceOfPlugin($dbconnection,$id);
				foreach ($service as $s)
				{
					$services_id[]=$s['service_id'];
				}
			}
		}
		else
		{
			$services_id=$param['serviceid'];
		}
		$services_all=array();
		foreach ($services_id as $i)
		{
			$services = Model_esia::getServices($dbconnection,null,$i,NULL,Model_esia::SERVICE_WITH_RRD);
			$services = $services[0];

			$services = exctractUnitServiceValue($dbconnection,$services);
			$common_name = Model_esia::getCommonName($lang, $services['name'], $services['check_plugin_name']);
			$services['common_name']=$common_name;
			if(!empty($services['value'])&& $services['value']!=null)
			{
				if($param['affiche_groupNoeud']==true)
				{
					$node = Model_esia::InstanceNode($dbconnection,$services['device_id']);
					$services['device_group_name']=$node->getGroup();
				}
				if($param['affiche_MinMax']==true)
				{
					$value = getServiceMaxMinValue($dbconnection,$services['id'],$gendate['start']['timestamp'],$gendate['end']['timestamp'],$rrdpath);
					$services['minMax']=$value;
				}
				if($param['affiche_MinMax']==true)
				{
					foreach($service['minMax'] as $key => $line )
					{
						if($line['unit'] =='B')
						{
							$smarty->assign('min',formatBytes($line['min'],2));
						}
						else
						{
							$smarty->assign('min',$line['min'].$line['unit']);
						}
					}
					foreach($service['minMax'] as $key => $line )
					{
						if($line['unit'] =='B')
						{
							$smarty->assign('max',formatBytes($line['max'],2));
						}
						else
						{
							$smarty->assign('max',$line['max'].$line['unit']);
						}
					}
					foreach($service['minMax'] as $key => $line )
					{
						if($line['unit'] =='B')
						{
							$smarty->assign('delta',formatBytes($line['delta'],2));
						}
						else
						{
							$smarty->assign('delta',$line['delta'].$line['unit']);
						}
					}
				}
			}
			$services_all[] =$services ;
		}
		$smarty->assign('services_all',$services_all);
	}
	elseif($param['type']=="groupenoeud" || $param['type']=="noeud" || $param['type']=="groupenoeudplugin")
	{
		$tab_id_node=nodeOrGroupNode($dbconnection,$param,$userid);
		$services_all=array();
		$list_pluginid=array();
		if(!empty($param['pluginid']) && $param['pluginid'][0] != -1)
		{
			if(!is_array($param['pluginid']))
			{
				$list_pluginid=array($param['pluginid']);
			}
			else 
			{
				$list_pluginid=$param['pluginid'];
			}
		}
		else 
		{
			$plugins = Model_esia::getPlugin($dbconnection);
			foreach($plugins as $plug)
			{
				$list_pluginid[] = $plug['id'];
			}
		}
		foreach ($tab_id_node as $node)
		{
			$services = Model_esia::getServices($dbconnection,$node['id'],null,NULL,Model_esia::SERVICE_WITH_RRD);
			
			foreach ($services as $key => $service)
			{
				if(in_array($service['plugin_id'], $list_pluginid))
				{
					$service = exctractUnitServiceValue($dbconnection,$service);
					if(!empty($service['value'])&& $service['value']!=null)
					{
						if($param['affiche_groupNoeud']==true)
						{
							$node = Model_esia::InstanceNode($dbconnection,$service['device_id']);
							$service['device_group_name']=$node['parent'];
						}
						if($param['affiche_MinMax']==true)
						{
							$value = getServiceMaxMinValue($dbconnection,$service['id'],$gendate['start']['timestamp'],$gendate['end']['timestamp'],$rrdpath);
							$service['minMax']=$value;
							
	// 						print_r($value);
						}
	// 					createelementTab($param,$service,$lang);
						//remplacer la function createelementTab :
	// 					$services=$services[0];
	
						$smarty->assign('device_group_name',$node['parent']);
						$smarty->assign('device_name',$service['device_name']);
						$smarty->assign('device_type',$service['device_type']);
						$smarty->assign('stdout',$service['stdout']);
						$smarty->assign('value',$service['value']);
	
						$common_name = Model_esia::getCommonName($lang, $service['name'], $service['check_plugin_name']);
						$service['common_name']=str_replace('_',' ',$common_name);
	
						if($param['affiche_MinMax']==true)
						{
							foreach($service['minMax'] as $key => $line )
							{
								if($line['unit'] =='B')
								{
									$service['min']=formatBytes($line['min'],2);
								}
								else
								{
									$service['min']=$line['min'].$line['unit'];
								}
							}
							foreach($service['minMax'] as $key => $line )
							{
								if($line['unit'] =='B')
								{
									$service['max']=formatBytes($line['max'],2);
								}
								else
								{
									$smarty->assign('max',$line['max'].$line['unit']);
									$service['max']=$line['max'].$line['unit'];
								}
							}
							foreach($service['minMax'] as $key => $line )
							{
								if($line['unit'] =='B')
								{
	// 								echo formatBytes($line['delta'],2).'<br />';
									$smarty->assign('delta',formatBytes($line['delta'],2));
									$service['delta']=formatBytes($line['delta'],2);
	// 								$services[$key]['delta']=formatBytes($line['delta'],2);
								}
								else
								{
	// 								echo $line['delta'].$line['unit'].'<br />';
									$smarty->assign('delta',$line['delta'].$line['unit']);
									$service['delta']=$line['delta'].$line['unit'];
	// 								$services[$key]['delta']=$line['delta'].$line['unit'];
								}
							}
						}
					}
					$services_all[] = $service;
				}
			}
		}
		$smarty->assign('services_all',$services_all);
	}
	$smarty->assign('affiche_groupNoeud',$param['affiche_groupNoeud']);
	$smarty->assign('affiche_type',$param['affiche_type']);
	$smarty->assign('affiche_message',$param['affiche_message']);
	$smarty->assign('affiche_MinMax',$param['affiche_MinMax']);

	//$smarty->assign('action','generate');
	$smarty->display($webplugin_path.'/blocks/templates/value_service.html');
}
elseif($action=="update")
{
	$parameters = $block['parameters'];

	$smarty->assign('block',$block);
	$smarty->assign('param',$parameters);
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];
			// Service & Noeud
			if($parameters['type']=='service')
			{
				$parameters['nodeid']=$_POST['nodes'];
				$parameters['serviceid']=$_POST['services'];
			}
			elseif ($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			else
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
				$parameters['pluginid']=$_POST['services'];
			}
			// Affichage colonne
			$parameters['affiche_message']=$_POST['messageError'];
			$parameters['affiche_groupNoeud']=$_POST['groupNoeud'];
			$parameters['affiche_type']=$_POST['type'];
			$parameters['affiche_MinMax']=$_POST['MinMAX'];
			$paramSave = json_encode($parameters);

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}

		$smarty->assign('param',$parameters);
	}
	//recupération des styles
	assignCommonStyles($smarty,$parameters);
	$listnode = array();
	$listgroupnode = array();
	$listservice = array();
	//Récupération des services
	if($parameters['type']=="service")
	{
		$smarty->assign('listservice',$parameters['serviceid']);
	}
	elseif($parameters['type']=="noeud")
	{
		$smarty->assign('listnode',$parameters['nodeid']);
	}
	else
	{
		$smarty->assign('listgroup',$parameters['groupnodeid']);
		if(!empty($parameters['pluginid']))
		{
			$smarty->assign('listplugin',$parameters['pluginid']);
		}
		else 
		{
			$smarty->assign('listplugin',array());
		}
	}
	$smarty->assign('adm_list_node',$list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
	$smarty->display($webplugin_path.'/blocks/templates/value_service.html');
}
function exctractUnitServiceValue($dbconnection,$service)
{
	$ret = null;
	$value=$service['value'];
	if(!empty($value) && $value!=null)
	{
		ksort($value,SORT_STRING|SORT_FLAG_CASE);
		foreach ($value as $key=>$val)
		{
			$unit = Model_esia::getRrdPlugin($dbconnection,$service['plugin_id'],$key);
			if($unit=='percent')$unit='%';
			elseif($unit=='Bytes')$unit='B';
			elseif ($unit=='temperature')$unit='°C';
			elseif ($unit=='Celsius')$unit='°C';
			elseif ($unit=='number'||$unit=='LINE1'||$unit=='AREA')$unit='';
			$value_service = $service['value'][$key];
			if ($key=='temperature_cpu1')$key='temperature cpu';
			elseif ($key=='temperature_sys')$key='temperature system';
			$ret = $ret."  ".ucfirst($key)." : ".$value_service." ".$unit." <br> ";
			//$ret[] = ucfirst($key)." : ".$service['value'][$key]." ".$unit." <br>";
		}
		$service['value']=rtrim($ret,' <br> ');
		//$service['value']=$ret;
		$service['stdout'] = explode('\|',$service['stdout']);
		$service['stdout']=$service['stdout'][0];
	}
	else
	{
		$service['value']="NO DATA";
	}

	$ret=$service;
	return $ret;
}


/**
 * @brief fais la difference entre noeud et groupe de noeud et retourne les bons param's
 * @detail retourne un array contenant les paramètres utlisés qu'importe que ce soit un noeud ou groupe de noeud
 * @param PDO $dbconnection
 * @param array $param contient les param du block
 * @retval unknown[][]|NULL[][]
 * @throw void
 */

function nodeOrGroupNode($dbconnection,$param,$userid)
{
	$tab_id_node=array();
	if($param['type']=="noeud")
	{
		foreach($param['nodeid'] as $val)
		{
			$node=Model_esia::InstanceNode($dbconnection,$val);
			$tab_id_node[] = array('id'=>$val,'parent'=>$node->getGroup(),'ip'=>$node->getIPAddress());
		}
	}
	else
	{
		foreach ($param['groupnodeid'] as $groupnode )
		{
			$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$groupnode);
			//$tab_group_node = Model_esia::getNodeList($dbconnection,null,$groupnode,$t_return = Model_esia::NODE_INSTANCE);
			foreach ($tab_group_node as $node)
			{
				$tab_id_node[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId(),'ip'=>$node->getIPAddress());
			}
		}
	}
	return $tab_id_node;
}

/**
 @brief retourne la valeur en % moyenne du service
 @detail retourne en pourcentage la valeur du service
 @params int $service_id l'identifiant du service
 @params string $interval nombre de jour de décalage (ex: -30d)
 @params string $dateFin Soit N si c'est aujourd'hui ou alors -'x'd  (x = valeur nombre de jour)
 @params string $rrdpath path pour les rrd
 @retval	int la valeur du service (%)
 @throw void
 */

function getServiceMaxMinValue($dbconnection,$service_id,$interval,$dateFin,$rrdpath)
{
	$query= $dbconnection->prepare("SELECT service_id,service_name,service_parameter,service_last_stdout,device_name,plugin_name,
								rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_vertical_label,rrd_graph_color,rrd_graph_type,rrd_regex_threshold,rrd_graph_num
							FROM esia_services
							JOIN esia_device ON device_id = service_device_id
							JOIN esia_plugins ON plugin_id = service_plugin_id
							JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id WHERE service_id=? ORDER BY rrd_graph_type,rrd_name;");
	$ret = $query->execute(array($service_id));
	if($ret===false)
	{
		$err = $query->errorInfo();
		echo "DB error: ".$err[2]."\n";
	}
	$arr_rrd=$query->fetchAll(PDO::FETCH_OBJ);
 //	echo '<pre>' ;
 //	print_r($arr_rrd);
// 	echo '</pre>' ;
	//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
	$list_file=array();
	$data = array();
	foreach($arr_rrd as $row)
	{
		$filename = $rrdpath.$row->device_name.'/'.$row->plugin_name.$row->service_id.$row->rrd_graph_num.'.rrd';
		if(is_file($filename) && !in_array($filename, $list_file))
		{
			$list_file[]=$filename;
			$ret = rrd_fetch($filename, array( "AVERAGE", "--start",$interval, "--end",$dateFin));
			foreach($ret['data'] as $key => $rrddata)
			{
				$min=null;
				$max=null;
				foreach($rrddata as $value)
				{
					if(stristr($value,'NAN')==FALSE)
					{
						if($min == null && $max ==null)
						{
							$min = $value;
							$max = $value;
						}
						if($value < $min)
						{
							$min = $value;
						}
						if($value > $max)
						{
							$max = $value;
						}
					}
				}
				$unit = $row->rrd_vertical_label;
				if($unit=='percent')$unit='%';
				elseif($unit=='Bytes')$unit='B';
				elseif ($unit=='temperature')$unit='°C';
				elseif ($unit=='Celsius')$unit='°C';
				elseif ($unit=='number'||$unit=='LINE1'||$unit=='AREA')$unit='';

				$data[strtolower($key)]=array('min'=>round($min,2),'max'=>round($max,2),'delta'=>round($max - $min,2),'unit'=>$unit);
			}
		}
	}
	ksort($data);
	return $data;
}
function formatBytes($bytes, $precision = 2) {
	$units = array('', 'KB', 'MB', 'GB', 'TB');
	$base = log($bytes, 1024);
	return round(pow(1024, $base - floor($base)), $precision) .' '. $units[floor($base)];
}
?>
